/*
 * linux/include/asm-arm/arch-ep93xx/system.h
 */

#include <asm/hardware.h>
#include <asm/mach-types.h>

static inline void arch_idle(void)
{
	cpu_do_idle();
}

static inline void arch_reset(char mode)
{
	u32 devicecfg;

	local_irq_disable();

	if (machine_is_ts72xx()) {
		__raw_writeb(0x5, TS72XX_WATCHDOG_FEED_PHYS_BASE);
		__raw_writeb(0x1, TS72XX_WATCHDOG_CONTROL_PHYS_BASE);
	} 

	if (!machine_is_ts72xx() || board_is_ts7350() || board_is_ts7370() || board_is_ts7390()) {
		devicecfg = __raw_readl(EP93XX_SYSCON_DEVICE_CONFIG);
		__raw_writel(0xaa, EP93XX_SYSCON_SWLOCK);
		__raw_writel(devicecfg | 0x80000000, EP93XX_SYSCON_DEVICE_CONFIG);
		__raw_writel(0xaa, EP93XX_SYSCON_SWLOCK);
		__raw_writel(devicecfg & ~0x80000000, EP93XX_SYSCON_DEVICE_CONFIG);
	}


	while (1)
		;
}
